var FDO = {
        
    populateMenu:
        function() {

            var menu = document.getElementById('foxden_popup');
            while (menu.firstChild) {
                menu.removeChild(menu.firstChild);
            }

            var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService);
                          
            FDO._upgradeFromPreviousVersion(prefs);

            var branch = prefs.getBranch("extensions.foxden.layout.");
            var prefTree = branch.getChildList("", {});
            
            prefTree.forEach(
                     function(prefName, index, arr) {
                        var prefParts = prefName.split('.');
                        if (prefParts[1] == 'name') {
                            var friendlyName = branch.getCharPref(prefName);
                            FDO._addMenuItem(prefParts[0], friendlyName);
                        }

                     }
            );

            menu.appendChild( document.createElement('menuseparator') );
            
            var config = document.createElement('menuitem');
            config.setAttribute('label', 'Configure...');
            config.addEventListener('command', FDO.openConfig, false);
            menu.appendChild(config);
        },
        
    _upgradeFromPreviousVersion:
        function(prefs) {
            
            var foxdenBranch = prefs.getBranch('extensions.foxden.');
            var oldDefaultLayout= foxdenBranch.getCharPref('layout');
            try {
                var newDefaultLayout = foxdenBranch.getCharPref('layout.default.layout');
            }
            catch (e) {}
            
            if (oldDefaultLayout && ! newDefaultLayout) {
                //dump('converted\n');
                foxdenBranch.setCharPref('layout.default.name', 'Your previous layout');
                foxdenBranch.setCharPref('layout.default.layout', oldDefaultLayout);
            }
            
        },
        
    _addMenuItem:
        function(slug, label) {
            var item = document.createElement('menuitem');
            item.setAttribute('label', label);
            item.setAttribute('id', slug);
            item.addEventListener('command',
                                  function() { FDO.openMainWindow(slug) },
                                  false);
            
            var menu = document.getElementById('foxden_popup');
            menu.appendChild(item);
        },
        
    openConfig:
        function() {
            openDialog("chrome://foxden/content/config.xul", "foxden_config");
        },
        
    openMainWindow:
        function(slug) {
    
            // Pass the layout name via a preference
            var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService);            
            var branch = prefs.getBranch("extensions.foxden.");
            branch.setCharPref('now_opening', slug);
            
            open("chrome://foxden/content/foxden.xul",
                 "Foxden_"+ slug,
                 "chrome,resizable=yes");
    }

}